package com.xxl.job.admin.controller;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.xxl.job.admin.controller.interceptor.PermissionInterceptor;
import com.xxl.job.admin.core.model.XxlJobInfo;
import com.xxl.job.admin.core.model.XxlJobLogGlue;
import com.xxl.job.admin.core.util.I18nUtil;
import com.xxl.job.admin.dao.XxlJobInfoDao;
import com.xxl.job.admin.dao.XxlJobLogGlueDao;
import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.glue.GlueTypeEnum;
import java.util.Date;
import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/jobcode"})
public class JobCodeController {
  @Resource
  private XxlJobInfoDao xxlJobInfoDao;
  
  @Resource
  private XxlJobLogGlueDao xxlJobLogGlueDao;
  
  @RequestMapping
  public String index(HttpServletRequest request, Model model, int jobId) {
    XxlJobInfo jobInfo = this.xxlJobInfoDao.loadById(jobId);
    List<XxlJobLogGlue> jobLogGlues = this.xxlJobLogGlueDao.findByJobId(jobId);
    if (jobInfo == null)
      throw new RuntimeException(I18nUtil.getString("jobinfo_glue_jobid_unvalid")); 
    if (GlueTypeEnum.BEAN == GlueTypeEnum.match(jobInfo.getGlueType()))
      throw new RuntimeException(I18nUtil.getString("jobinfo_glue_gluetype_unvalid")); 
    PermissionInterceptor.validJobGroupPermission(request, jobInfo.getJobGroup());
    model.addAttribute("GlueTypeEnum", GlueTypeEnum.values());
    model.addAttribute("jobInfo", jobInfo);
    model.addAttribute("jobLogGlues", jobLogGlues);
    return "jobcode/jobcode.index";
  }
  
  @RequestMapping({"/save"})
  @ResponseBody
  public ReturnT<String> save(HttpServletRequest request, int id, String glueSource, String glueRemark) {
    if (glueRemark == null)
      return new ReturnT(500, I18nUtil.getString("system_please_input") + I18nUtil.getString("jobinfo_glue_remark")); 
    if (glueRemark.length() < 4 || glueRemark.length() > 100)
      return new ReturnT(500, I18nUtil.getString("jobinfo_glue_remark_limit")); 
    XxlJobInfo existsJobInfo = this.xxlJobInfoDao.loadById(id);
    if (existsJobInfo == null)
      return new ReturnT(500, I18nUtil.getString("jobinfo_glue_jobid_unvalid")); 
    PermissionInterceptor.validJobGroupPermission(request, existsJobInfo.getJobGroup());
    existsJobInfo.setGlueSource(glueSource);
    existsJobInfo.setGlueRemark(glueRemark);
    existsJobInfo.setGlueUpdatetime(new Date());
    existsJobInfo.setUpdateTime(new Date());
    this.xxlJobInfoDao.update(existsJobInfo);
    XxlJobLogGlue xxlJobLogGlue = new XxlJobLogGlue();
    xxlJobLogGlue.setJobId(existsJobInfo.getId());
    xxlJobLogGlue.setGlueType(existsJobInfo.getGlueType());
    xxlJobLogGlue.setGlueSource(glueSource);
    xxlJobLogGlue.setGlueRemark(glueRemark);
    xxlJobLogGlue.setAddTime(new Date());
    xxlJobLogGlue.setUpdateTime(new Date());
    this.xxlJobLogGlueDao.save(xxlJobLogGlue);
    this.xxlJobLogGlueDao.removeOld(existsJobInfo.getId(), 30);
    return ReturnT.SUCCESS;
  }
}
